﻿Imports System.Data.SqlClient
Imports System.Runtime.InteropServices
Module module1
    Public global_conn As New SqlConnection
    Public Function IsIt64() As Boolean
        Return (IntPtr.Size = 8)
    End Function
    <DllImport("dbd_clnt.dll", EntryPoint:="Initialize", CharSet:=CharSet.Unicode)> _
        Public Function Initialize(ByVal ask As Boolean) As Integer
    End Function
    <DllImport("dbd_clnt64.dll", EntryPoint:="Initialize", CharSet:=CharSet.Unicode)> _
    Public Function Initialize64(ByVal ask As Boolean) As Integer
    End Function
    <DllImport("dbd_clnt.dll", EntryPoint:="AddPassword", CharSet:=CharSet.Unicode)> _
    Public Function AddPassword(ByVal db As String, ByVal Pass As String) As Integer
    End Function
    <DllImport("dbd_clnt64.dll", EntryPoint:="AddPassword", CharSet:=CharSet.Unicode)> _
    Public Function AddPassword64(ByVal db As String, ByVal Pass As String) As Integer
    End Function
End Module

Public Class Form1




    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        'Authorize EACH connection 
        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        conn = New SqlConnection("Server=.\sql2005;Trusted_connection=yes")

        Try
            conn.Open()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        conn.ChangeDatabase("db1")

        cmd = New SqlCommand("open symmetric key dbdx decryption by password='111'", conn)
        cmd.ExecuteNonQuery()
        ' ONLY THIS CONNECTION IS AUTHORIZED!!!!
        ' Other connections will fail without OPEN KEY statement
        ' Thats why we assign already opened connection:
        Me.Table_1TableAdapter.Connection = conn

        Me.Table_1TableAdapter.Fill(Me.Db1DataSet.Table_1)
        Button2.Enabled = False
        Button3.Enabled = False
        Button1.Enabled = False
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Authorize one global connection and open access for all connections
        ' It must be global and persistent connection to hold unlock as long as
        ' application runs
        Dim cmd As SqlCommand
        If global_conn.State <> ConnectionState.Open Then
            global_conn.ConnectionString = "Server=.\sql2005;Trusted_connection=yes;Pooling=false"

            Try
                global_conn.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
            global_conn.ChangeDatabase("db1")

            cmd = New SqlCommand("open symmetric key dbdx decryption by password='111'", global_conn)
            cmd.ExecuteNonQuery()
            ' Now we share access to the database for all connections of the application
            cmd = New SqlCommand("exec dbd_unlock_for_host @proc=1", global_conn)
            cmd.ExecuteNonQuery()


        End If
        ' the following will create new connection, but it does not matter
        ' all connections are allowed now
        Me.Table_1TableAdapter.Fill(Me.Db1DataSet.Table_1)
        Button1.Enabled = False
        Button2.Enabled = False
        Button3.Enabled = False

    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' we load so called connection proxy and setup database/password parameter

        If IsIt64() Then
            Initialize64(True)
            AddPassword64("db1", "111")
        Else
            Initialize(True)
            AddPassword("db1", "111")
        End If
        ' all connections opened by our program SINCE NOW automatically 
        ' runs OPEN KEY statement automatically

        ' ALSO: All SQL Queries are encrypted and not visible over network!!!
        Me.Table_1TableAdapter.Fill(Me.Db1DataSet.Table_1)
        Button2.Enabled = False
        Button1.Enabled = False
        Button3.Enabled = False

    End Sub


    Private Sub DataGridView1_CellEndEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellEndEdit
        Me.Table_1TableAdapter.Update(Me.Db1DataSet)
    End Sub
End Class
